// The CERN-OHL-P v2 License
//
// Copyright (c) Since 2024 RIGHTxLIGHT Co., Ltd.
//
// This source describes Open Hardware and is licensed under the CERN-OHL-P v2.
// You may redistribute and modify this documentation and make products using it under the terms of
// the CERN-OHL-P v2 (https:/cern.ch/cern-ohl). This documentation is distributed WITHOUT ANY
// EXPRESS OR IMPLIED WARRANTY, INCLUDING OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A
// PARTICULAR PURPOSE. Please see the CERN-OHL-P v2 for applicable conditions.
//
// Revisions:
// Rev.1.0		2024/04/16		Initial release
//
// -------------------------------------------------------------------------------------------------
module edge_det # (
		parameter CLOCK_POL = 1,
		parameter RESET_POL = 0,
		parameter ARESET = 1
	) (
		input CLOCK,
		input RESET,
		input IN_DATA,
		output OUT_RISE,
		output OUT_FALL
	);

	wire data;
	
	assign OUT_RISE = (IN_DATA) & (!data);
	assign OUT_FALL = (!IN_DATA) & (data);

	d_ff # (
		.CLOCK_POL(CLOCK_POL),
		.RESET_POL(RESET_POL),
		.ARESET(ARESET),
		.DATA_WIDTH(1)
	) d_ff_u1 (
		.CLOCK(CLOCK), 
		.RESET(RESET), 
		.IN_DATA(IN_DATA),
		.OUT_DATA(data)
	);

endmodule
