// The MIT License
//
// Copyright (c) Since 2024 RIGHTxLIGHT Co., Ltd.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software
// and associated documentation files (the “Software”), to deal in the Software without restriction,
// including without limitation the rights to use, copy, modify, merge, publish, distribute,
// sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// Revisions:
// Rev.1.0		2024/04/16		Initial release
//
// -------------------------------------------------------------------------------------------------
#include <bsp.h>

#include "apb3.h"

void apb3_dispVerDate(void)
{
	union {
		u32 value;
		fpga_version_t ver;
		fpga_date_t date;
	} data;

	data.value = apb3_readVersion(APB0);
	bsp_printf("FPGA Version : %c.%c%c%c ", data.ver.major, data.ver.minor[1], data.ver.minor[0], data.ver.rev);

	data.value = apb3_readDate(APB0);
	bsp_printf("%d/%d/%d\r\n", data.date.yyyy, data.date.mm, data.date.dd);
}

void set_led(sled_t led)
{
	volatile sled_t sled_reg;

	do {
		sled_reg.u32 = apb3_readSled(APB0);
	} while (sled_reg.busy);
	apb3_setSled(APB0, led.u32);
}
