// The MIT License
//
// Copyright (c) Since 2024 RIGHTxLIGHT Co., Ltd.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software
// and associated documentation files (the “Software”), to deal in the Software without restriction,
// including without limitation the rights to use, copy, modify, merge, publish, distribute,
// sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// Revisions:
// Rev.1.0		2024/04/16		Initial release
//
// -------------------------------------------------------------------------------------------------
#include <stdbool.h>

#include <bsp.h>
#include <spi.h>


#define SPI		SYSTEM_SPI_1_IO_CTRL

void spiInit(void)
{
	spi_applyConfig(SPI, &(Spi_Config) {
			.cpol = 0,
			.cpha = 0,
			.mode = 0, 					// Assume full duplex (standard SPI)
			.clkDivider = 10,			// SPI frequency = FCLK/((clockDivider+1)*2) = 25MHz / ((10+1)*2) = 1.136363636 MHz (AD3008 max 1.35MHz)
			.ssSetup = 5,				// 5 / 25MHz = 200ns (AD3008 min 100ns)
			.ssHold = 5,				// 5 / 25MHz = 200ns
			.ssDisable = 10,			// 10 / 25MHz = 400ns (AD3008 min 270ns)
		}
	);
}
